with Standard_Integer_VecVecs;
with Standard_Floating_VecVecs;
with Standard_Complex_VecVecs;

package Standard_Random_VecVecs is

-- DESCRIPTION :
--   Offers routines to generate vecvecs of random standard numbers.

  function Random_VecVec ( n,m : natural; low,upp : integer )
                         return Standard_Integer_VecVecs.VecVec;

  -- DESCRIPTION : 
  --   Returns m vectors of range 1..n with entries between low and upp.
  --   The structure on return has range 1..m.

  function Random_VecVec ( n,m : natural )
                         return Standard_Floating_VecVecs.VecVec;

  -- DESCRIPTION :
  --   Returns m vectors of range 1..n with random floating numbers.
  --   The structure on return has range 1..m.

  function Random_VecVec ( n,m : natural )
                         return Standard_Complex_VecVecs.VecVec;

  -- DESCRIPTION :
  --   Returns m vectors of range 1..n with random complex numbers.
  --   The structure on return has range 1..m.

end Standard_Random_VecVecs;
