with text_io;                            use text_io;

package Standard_Natural_Numbers_io is

-- DESCRIPTION :
--   Definitions of the input/output routines for standard naturals.

  procedure get ( file : in file_type; n : in out natural );

  -- DESCRIPTION :
  --   Reads a natural number from file.

  procedure put ( file : in file_type; n : in natural );

  -- DESCRIPTION :
  --   Writes a natural number to the file, with no spaces in front.

  procedure put ( file : in file_type; n,dp : in natural );

  -- DESCRIPTION :
  --   Writes the number on file, using at least dp decimal places.
  --   If the number needs less space in its display,
  --   then blanks are added in front of the number. 

end Standard_Natural_Numbers_io;
