with Standard_Floating_Numbers;          use Standard_Floating_Numbers;
with Standard_Complex_Numbers;           use Standard_Complex_Numbers;

package Standard_Random_Numbers is

-- DESCRIPTION :
--   This package provides random number generators for machine numbers.

  function Random ( lower,upper : integer ) return integer;

  -- DESCRIPTION :
  --   lower <= Random(lower,upper) <= upper, randomly generated.

  function Random return double_float;

  -- DESCRIPTION :
  --   Returns a random floating-point number in [-1,1].

  function Random return Complex_Number;

  -- DESCRIPTION :
  --   Returns a random complex number, with real and imaginary
  --   part in [-1,1].

  function Random ( modulus : double_float ) return Complex_Number;

  -- DESCRIPTION :
  --   Generates a random complex number with a given modulus,
  --   so only the argument angle will be chosen at random.

  function Random1 return Complex_Number;

  -- DESCRIPTION :
  --   Generates a random complex number with modulus one.

end Standard_Random_Numbers;
