with Standard_Integer_Vectors;           use Standard_Integer_Vectors;
with Standard_Integer_VecVecs;           
with Standard_Floating_VecVecs;

package Face_Cardinalities is

-- DESCRIPTION :
--   This package provides a naive facility for counting the number of
--   k-dimensional faces of a polytope.

-- NOTE :
--   The precision is very likely to be insufficient even to count
--   the number of faces.

  function fvector ( pts : in Standard_Integer_VecVecs.VecVec ) return Vector;

  function fvector ( pts : in Standard_Floating_VecVecs.VecVec ) return Vector;

  -- DESCRIPTION :
  --   Computes the f-vector of a polytope.

  -- ON ENTRY :
  --   pt          a vector of integer points, the polytope is conv(pts).

  -- ON RETURN :
  --   f(-1..n)    the f-vector of conv(pts):
  --                f(-1) = 1, f(0) = #vertices, f(1) = #edges, .. ,
  --                f(n-1) = #facets, f(n) = 1, if conv(pts) is n-dimensional.

end Face_Cardinalities;
