with Bracket_Polynomials;                use Bracket_Polynomials;

package Bracket_Systems is

-- DESCRIPTION :
--   This package contains routines to manipulate systems of
--   bracket polynomials.

  type Bracket_System is array ( integer range <> ) of Bracket_Polynomial;

  function Straightening_Syzygies ( n,d : natural ) return Bracket_System;

  -- DESCRIPTION :
  --   Returns the system of straightening syzygies that forms a Groebner
  --   basis for the ideal of all d-planes in n-space.

  procedure Clear ( s : in out Bracket_System );

  -- DESCRIPTION :
  --   Deallocates the space occupied by the bracket system.

end Bracket_Systems;
